import withResolvers from './utils/withResolvers';
class RicTracker {
    #idleCallbackId;
    #idleDeadline;
    #deferred;
    constructor() {
        this.#deferred = withResolvers();
    }
    get available() {
        return typeof requestIdleCallback !== 'undefined';
    }
    get deadline() {
        return this.#idleDeadline;
    }
    async waitIdleCallback() {
        return this.#deferred.promise;
    }
    start() {
        if (!this.available || this.#idleCallbackId !== undefined) {
            return;
        }
        this.#idleCallbackId = requestIdleCallback((deadline) => {
            this.#idleDeadline = deadline;
            this.#idleCallbackId = undefined;
            this.#deferred.resolve(deadline);
            this.#deferred = withResolvers();
            this.start();
        });
    }
    stop() {
        cancelIdleCallback(this.#idleCallbackId);
        this.#idleCallbackId = undefined;
    }
}
const ricTracker = new RicTracker();
export default ricTracker;
